/*
 ============================================================================
 Name        : principal.cpp
 Author      : Anderson Moreira
 E-mail		 : anderson.moreira@recife.ifpe.edu.br
 Version     : 13/06/2011
 Copyright   : 
 Description : Simula o uso de semforos pelo sistema operacional
 	 	 	   Execute o programa SEMAFORO_1
    		   Execute o comando ipcs -s no Linux (no Cygwin aparece Bad System call)
  	  	  	   Execute novamente o programa SEMAFORO_1 e analise a resposta
  	  	  	   Execute o comando ipcrm -s <id> para remover o conjunto de semrofos
  	  	  	   Em semaforo.h, altere o valor de semflag e analise os resultados.
 ============================================================================
 */

#include <stdio.h>
#include "semaforo.h"

int  main(void)
{
	//Semaforo(key_t chave,int valor_inicial_do_semaforo,flags_de_permissao);
	Semaforo sem1(1234,1,0666|IPC_CREAT);
	int i=0, t_sono;

	printf("Digite o valor do tempo de sono = ");
	scanf("%d", &t_sono);
	printf("\n O programa vai dormir por intervalos de %d segundos\n", t_sono);

	while(i< 10)
    {
		i = i+ 1;
		printf("Sou o programa SEMAFORO_1\n");
		printf("Vou Executar o metodo P()\n");
		sem1.P();
		printf("Vou dormir por %ds\n", t_sono);
		printf("Numero do sono = %d\n", i);
		sleep(t_sono);
		printf("Vou Executar o metodo V()\n");
		sem1.V();
		sleep(1);
		printf("Vou terminar\n");
    }//fim do while
}
